<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Symbol Table Hierarchy</TITLE>
<link href="suif1_42.html" rel=Next>
<link href="suif1_40.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_40.html">previous</A>, <A HREF="suif1_42.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC41" HREF="suif1_toc.html#TOC41">Symbol Table Hierarchy</A></H2>

<P>
<A NAME="IDX261"></A>
<A NAME="IDX262"></A>
<A NAME="IDX263"></A>
The SUIF symbol tables are organized in a hierarchy of nested scopes and
maintained internally within a tree structure.  Every table contains a
list of the symbol tables that are its children, and each table also has
a pointer back to its parent in the tree (except for the global symbol
table which does not have a parent).  The <CODE>children</CODE> method returns
a pointer to the list of children and the <CODE>parent</CODE> method gets the
pointer to the parent symbol table.  Thus, to search through all of the
enclosing scopes, one can follow the parent pointers back to the global
symbol table, visiting all of the symbol tables along the way.  The
<CODE>is_ancestor</CODE> method provides an easy way to check if a given
symbol table is an ancestor (i.e. an enclosing scope) of the current
table.

</P>
<P>
Note that the symbol table hierarchy is not independent.  The primary
objects in a SUIF program are the files and the abstract syntax trees
for the procedures.  The symbol tables are always attached to these
primary objects and are generally treated as if they are parts of those
objects.  For example, when a block of code is deleted the associated
symbol table is automatically removed from the hierarchy and deleted.

</P>
<P>
<A NAME="IDX264"></A>
The <CODE>base_symtab</CODE> class is the base class from which the other
symbol table classes are derived, but it is an abstract class and cannot
be used directly.  There are four different derived symbol tables
classes.  They have much in common, but each is used at a different
level in the hierarchy and thus has slightly different features.

</P>

<UL>
<LI><A HREF="suif1_42.html#SEC42">Global Symbol Table</A>: Global scope (shared across files).
<LI><A HREF="suif1_43.html#SEC43">File Symbol Tables</A>: File-level global scopes.
<LI><A HREF="suif1_44.html#SEC44">Procedure Symbol Tables</A>: Top-level procedure scopes.
<LI><A HREF="suif1_45.html#SEC45">Block Symbol Tables</A>: Nested scopes within procedures.
</UL>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_40.html">previous</A>, <A HREF="suif1_42.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
